/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/

package org.jboss.serial.contribtests.customertest;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * @author prashantp
 * @version $Revision: 137 $
 */
public class Address implements Serializable {
    /**
     *
     */
    private static final long serialVersionUID = 8167474586901266782L;
    private Long id;
    private String addressLine1;
    private String addressLine2;
    private String addressLine3;
    private List histories;

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getAddressLine1() {
        return addressLine1;
    }

    /**
     * DOCUMENT ME!
     *
     * @param addressLine1 DOCUMENT ME!
     */
    public void setAddressLine1(String addressLine1) {
        this.addressLine1 = addressLine1;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getAddressLine2() {
        return addressLine2;
    }

    /**
     * DOCUMENT ME!
     *
     * @param addressLine2 DOCUMENT ME!
     */
    public void setAddressLine2(String addressLine2) {
        this.addressLine2 = addressLine2;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getAddressLine3() {
        return addressLine3;
    }

    /**
     * DOCUMENT ME!
     *
     * @param addressLine3 DOCUMENT ME!
     */
    public void setAddressLine3(String addressLine3) {
        this.addressLine3 = addressLine3;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public Long getId() {
        return id;
    }

    /**
     * DOCUMENT ME!
     *
     * @param id DOCUMENT ME!
     */
    public void setId(Long id) {
        this.id = id;
    }

    /**
     * DOCUMENT ME!
     *
     * @param history DOCUMENT ME!
     */
    public void addHistory(AddressHistory history) {
        if (histories == null) {
            histories = new ArrayList();
        }

        histories.add(history);
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public List getHistories() {
        return histories;
    }

    /**
     * DOCUMENT ME!
     *
     * @param obj DOCUMENT ME!
     * @return DOCUMENT ME!
     */
    public boolean equals(Object obj) {
        if (!(obj instanceof Address)) {
            return false;
        }

        if (obj == null) {
            return false;
        }

        if (((Address) obj).getId() == null) {
            return false;
        }

        return ((Address) obj).getId().equals(id);
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int hashCode() {
        return id.hashCode();
    }
}