/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/

package org.jboss.serial.contribtests.customertest;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * $Id: Customer.java 217 2006-04-18 18:42:42Z csuconic $
 *
 * @author <a href="mailto:clebert.suconic@jboss.com">Clebert Suconic</a>
 */

/**
 * @author prashantp
 * @version $Revision: 217 $
 */
public class Customer implements Serializable {
    /**
     *
     */
    private static final long serialVersionUID = -2069159504301052159L;
    private Long id;
    private String firstName;
    private String lastName;
    private Integer gender;
    private Integer status;
    private Integer phoneNumber;
    private Address address;
    private List policies;
    private List histories;
    private Long policyId;

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getFirstName() {
        return firstName;
    }

    /**
     * DOCUMENT ME!
     *
     * @param firstName DOCUMENT ME!
     */
    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public Integer getGender() {
        return gender;
    }

    /**
     * DOCUMENT ME!
     *
     * @param gender DOCUMENT ME!
     */
    public void setGender(Integer gender) {
        this.gender = gender;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getLastName() {
        return lastName;
    }

    /**
     * DOCUMENT ME!
     *
     * @param lastName DOCUMENT ME!
     */
    public void setLastName(String lastName) {
        this.lastName = lastName;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public Integer getPhoneNumber() {
        return phoneNumber;
    }

    /**
     * DOCUMENT ME!
     *
     * @param phoneNumber DOCUMENT ME!
     */
    public void setPhoneNumber(Integer phoneNumber) {
        this.phoneNumber = phoneNumber;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public Integer getStatus() {
        return status;
    }

    /**
     * DOCUMENT ME!
     *
     * @param status DOCUMENT ME!
     */
    public void setStatus(Integer status) {
        this.status = status;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public Long getId() {
        return id;
    }

    /**
     * DOCUMENT ME!
     *
     * @param id DOCUMENT ME!
     */
    public void setId(Long id) {
        this.id = id;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public Address getAddress() {
        return address;
    }

    /**
     * DOCUMENT ME!
     *
     * @param address DOCUMENT ME!
     */
    public void setAddress(Address address) {
        this.address = address;
    }

    /**
     * DOCUMENT ME!
     *
     * @param policy DOCUMENT ME!
     */
    public void addPolicy(Policy policy) {
        if (policies == null) {
            policies = new ArrayList();
        }

        policies.add(policy);
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public List getPolicies() {
        return policies;
    }

    /**
     * DOCUMENT ME!
     */
    public void resetPolicies() {
        this.policies = null;
    }

    /**
     * DOCUMENT ME!
     *
     * @param obj DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     *//*
    public boolean equals(Object obj) {
        if (!(obj instanceof Customer)) {
            return false;
        }

        if (obj == null) {
            return false;
        }

        if (((Customer) obj).getId() == null) {
            return false;
        }

        return ((Customer) obj).getId().equals(id);
    }

    *//**
 * DOCUMENT ME!
 *
 * @return DOCUMENT ME!
 *//*
    public int hashCode() {
        return id.hashCode();
    }*/

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public List getHistory() {
        return histories;
    }

    /**
     * DOCUMENT ME!
     *
     * @param history DOCUMENT ME!
     */
    public void addHistory(CustomerHistory history) {
        if (histories == null) {
            histories = new ArrayList();
        }

        histories.add(history);
    }

    public Long getPolicyId() {
        return policyId;
    }

    public void setPolicyId(Long policyId) {
        this.policyId = policyId;
    }
}