/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/

package org.jboss.serial.contribtests.customertest;

import junit.framework.TestCase;

import java.io.File;

/**
 * $Id: CustomerTestCase.java 254 2006-04-28 21:12:54Z csuconic $
 *
 * @author <a href="mailto:clebert.suconic@jboss.com">Clebert Suconic</a>
 */
public class CustomerTestCase extends TestCase {

    public void test100JBoss() throws Exception {
        System.out.println();
        System.out.println("test-100-jboss-serialization");
        Object objToWrite = ModelServer.getInsuranceModelHundredCustomers();

        FileSystemResultKeeperDao dao = new FileSystemResultKeeperDao();
        File fileWritten = dao.keepResult(objToWrite, true, true);
        dao.getResult(fileWritten, true, true);

        long startTimeWrite = System.currentTimeMillis();
        fileWritten = dao.keepResult(objToWrite, true, false);
        long finishTimeWrite = System.currentTimeMillis();

        System.out.println("Time to write = " + (finishTimeWrite - startTimeWrite));


        long startTimeRead = System.currentTimeMillis();
        Object objRead = dao.getResult(fileWritten, true, false);
        long finishTimeRead = System.currentTimeMillis();

        System.out.println("Time to read = " + (finishTimeRead - startTimeRead));
    }

    public void test100JBossIndirect() throws Exception {
        System.out.println();
        System.out.println("test-100-jboss-serialization-indiret");
        Object objToWrite = ModelServer.getInsuranceModelHundredCustomers();

        FileSystemResultKeeperDao dao = new FileSystemResultKeeperDao();

        long startTimeWrite = System.currentTimeMillis();
        File fileWritten = dao.keepResult(objToWrite, true, true);
        long finishTimeWrite = System.currentTimeMillis();

        System.out.println("Time to write = " + (finishTimeWrite - startTimeWrite));


        long startTimeRead = System.currentTimeMillis();
        Object objRead = dao.getResult(fileWritten, true, true);
        long finishTimeRead = System.currentTimeMillis();

        System.out.println("Time to read = " + (finishTimeRead - startTimeRead));
    }

    public void test100Java() throws Exception {
        System.out.println();
        System.out.println("test-100-JavaSerialization-1.5");
        Object objToWrite = ModelServer.getInsuranceModelHundredCustomers();

        FileSystemResultKeeperDao dao = new FileSystemResultKeeperDao();

        long startTimeWrite = System.currentTimeMillis();
        File fileWritten = dao.keepResult(objToWrite, false, false);
        long finishTimeWrite = System.currentTimeMillis();

        System.out.println("Time to write = " + (finishTimeWrite - startTimeWrite));


        long startTimeRead = System.currentTimeMillis();
        Object objRead = dao.getResult(fileWritten, false, false);
        long finishTimeRead = System.currentTimeMillis();

        System.out.println("Time to read = " + (finishTimeRead - startTimeRead));
    }


    public void test50JBoss() throws Exception {
        System.out.println();
        System.out.println("test-50-JBoss");
        Object objToWrite = ModelServer.getInsuranceModelFitfyCustomer();

        FileSystemResultKeeperDao dao = new FileSystemResultKeeperDao();

        long startTimeWrite = System.currentTimeMillis();
        File fileWritten = dao.keepResult(objToWrite, true, false);
        long finishTimeWrite = System.currentTimeMillis();

        System.out.println("Time to write = " + (finishTimeWrite - startTimeWrite));


        long startTimeRead = System.currentTimeMillis();
        Object objRead = dao.getResult(fileWritten, true, false);
        long finishTimeRead = System.currentTimeMillis();

        System.out.println("Time to read = " + (finishTimeRead - startTimeRead));
    }


    public void test50Java() throws Exception {
        System.out.println();
        System.out.println("test-50-Java");
        Object objToWrite = ModelServer.getInsuranceModelFitfyCustomer();

        FileSystemResultKeeperDao dao = new FileSystemResultKeeperDao();

        long startTimeWrite = System.currentTimeMillis();
        File fileWritten = dao.keepResult(objToWrite, false, false);
        long finishTimeWrite = System.currentTimeMillis();

        System.out.println("Time to write with JBS = " + (finishTimeWrite - startTimeWrite));


        long startTimeRead = System.currentTimeMillis();
        Object objRead = dao.getResult(fileWritten, false, false);
        long finishTimeRead = System.currentTimeMillis();

        System.out.println("Time to read with JBS = " + (finishTimeRead - startTimeRead));
    }


}
