package org.jboss.serial.contribtests.jbser121;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;

import junit.framework.TestCase;

import org.jboss.serial.io.JBossObjectInputStream;
import org.jboss.serial.io.JBossObjectOutputStream;

public class JBSER121TestCase extends TestCase {

	/**
	 * This test should pass for all newer JVMs as long as the property  
	 * org.jboss.serial.SYNC_SERIALIZATION_BINARY_FORMATS is true
	 * 
	 * @throws Exception
	 */
	public void testSerializationForAllJVMs() throws Exception {
		ByteArrayOutputStream byteOut = new ByteArrayOutputStream();
		JBossObjectOutputStream os = new JBossObjectOutputStream(byteOut);
		os.writeObject(MyEntity.createInstance());
		os.flush();

		ByteArrayInputStream byteInpt = new ByteArrayInputStream(byteOut.toByteArray());
		JBossObjectInputStream is = null;
		try {
			is = new JBossObjectInputStream(byteInpt);
			MyEntity ent = (MyEntity) is.readObject();
		} catch (IOException e) {
			fail("Failed to revert an object with a java.io.File embedded. This happens if you are using a JVM newer than JDK 1.6.0_19 and you didn't set the property org.jboss.serial.SYNC_SERIALIZATION_BINARY_FORMATS");
		}
	}
}
