package org.jboss.serial.contribtests.jbser121;

import java.io.File;
import java.io.IOException;

public class MyEntity {
	private File file;

	// just to prevent direct instantiation
	private MyEntity() {
	}
	
	public static MyEntity createInstance() {
		MyEntity entity = new MyEntity();
		entity.init();
		return entity;
	}
	
	// In an EJB, this would be a PostConstruct
	public void init() {
		try {
			this.file = File.createTempFile("jbser121", "txt");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}
	
	// In an EJB, this would be the PreDestroy
	public void destroy() {
		this.file.delete();
	}
}
