/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/

package org.jboss.serial.data;

import java.io.Serializable;
import java.util.Random;

/**
 * $Id: TestArrayDouble.java 217 2006-04-18 18:42:42Z csuconic $
 *
 * @author <a href="mailto:clebert.suconic@jboss.com">Clebert Suconic</a>
 */
public class TestArrayDouble implements Serializable {

    public static final int ARRAY_SIZE=50;
    int x;

    TestDomainObject[][] arrayDouble;

    public TestArrayDouble()
    {
        x = new Random().nextInt();
        arrayDouble = new TestDomainObject[10][];
        for (int i=0;i<10;i++)
        {
            arrayDouble[i] = new TestDomainObject[10];
            for (int j=0;j<10;j++)
            {
                arrayDouble[i][j] = new TestDomainObject(false);
            }
        }
    }

    public static TestArrayDouble createTestInstance()
    {
        return new TestArrayDouble();
    }


    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        final TestArrayDouble testArray = (TestArrayDouble) o;

        if (x != testArray.x) return false;

        for (int i=0;i<arrayDouble.length;i++)
        {
            for (int j=0;j<arrayDouble[i].length;j++)
            {
                if (!arrayDouble[i][j].equals(testArray.arrayDouble[i][j])) 
                	{
                	    System.out.println("this.[" + i + "][" + j + "]=" + arrayDouble[i][j] + " while that.[" + i + "][" + j + "]=" + testArray.arrayDouble[i][j]);
                	    return false;
                	}
            }
        }

        return true;
    }

    public int hashCode() {
        return x;
    }

}
