/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/

package org.jboss.serial.data;

import java.io.File;

public class TestNonSerializableFile implements NonSerializableTest
{
	
	File someFile;
	public TestNonSerializableFile()
	{
		try
		{
			this.someFile = new File("/tmp/someFile");
			someFile.createNewFile();
		}
		catch (Exception e)
		{
			throw new RuntimeException(e);
		}
	}

	public static TestNonSerializableFile createTestInstance()
	{
		return new TestNonSerializableFile();
	}

	public void doSomething() throws Exception {
		if (someFile.exists())
		{
			someFile.delete();
		}
	}
	
	public boolean equals (Object obj)
	{
		TestNonSerializableFile that = (TestNonSerializableFile)obj;
		return this.someFile.equals(that.someFile);
	}
}
