/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/

package org.jboss.serial.data;

import org.jboss.serial.data.proxy.InterfaceForProxy;
import org.jboss.serial.data.proxy.ProxiedClass;

import java.util.Random;
import java.io.Serializable;

/**
 * $Id: TestProxy.java 226 2006-04-20 20:50:00Z csuconic $
 *
 * @author <a href="mailto:clebert.suconic@jboss.com">Clebert Suconic</a>
 */
public class TestProxy implements Serializable {

    int a;
    int b;
    InterfaceForProxy proxy;
    InterfaceForProxy secondCircularReference;

    public TestProxy()
    {
        a = new Random().nextInt();
        b = new Random().nextInt();
        proxy = ProxiedClass.createMyProxy(a,b);
        secondCircularReference = proxy;

    }


    public boolean equals(Object obj)
    {
        return proxy.doSomething()==((TestProxy)obj).proxy.doSomething() &&
               secondCircularReference.doSomething()==((TestProxy)obj).secondCircularReference.doSomething();
    }

    public static TestProxy createTestInstance()
    {
        return new TestProxy();
    }


    public InterfaceForProxy getProxy() {
        return proxy;
    }


}
