/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/

package org.jboss.serial.data;

import java.math.BigDecimal;
import java.util.Random;
import java.util.Comparator;

/**
 * $Id: TestWithBigDecimal.java 217 2006-04-18 18:42:42Z csuconic $
 *
 * @author <a href="mailto:clebert.suconic@jboss.com">Clebert Suconic</a>
 */
public class TestWithBigDecimal implements java.io.Serializable, Comparator {

    BigDecimal value;
    BigDecimal value2 = null;

    

    public BigDecimal getValue()
	{
		return value;
	}


	public void setValue(BigDecimal value)
	{
		this.value = value;
	}


	public BigDecimal getValue2()
	{
		return value2;
	}


	public void setValue2(BigDecimal value2)
	{
		this.value2 = value2;
	}


	public static TestWithBigDecimal createTestInstance()
    {
        TestWithBigDecimal x = new TestWithBigDecimal();

        x.value = new BigDecimal(new Random().nextDouble());
        x.value2 = new BigDecimal(new Random().nextDouble());

        return x;
    }


    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        final TestWithBigDecimal that = (TestWithBigDecimal) o;

        if (value != null ? !value.equals(that.value) : that.value != null) return false;

        return true;
    }

    public int hashCode() {
        return (value != null ? value.hashCode() : 0);
    }

    public int compare(Object o1, Object o2) {
        TestWithBigDecimal r1 = (TestWithBigDecimal) o1;
        TestWithBigDecimal r2 = (TestWithBigDecimal) o2;

        return r1.value.compareTo(r2.value);
    }

}
