/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/

package org.jboss.serial.nonserializable;

import java.util.ArrayList;
import java.util.Random;

/**
 * $Id: NonSerializableTestData.java 211 2006-04-17 23:12:14Z csuconic $
 *
 * @author <a href="mailto:clebert.suconic@jboss.com">Clebert Suconic</a>
 */
public class NonSerializableTestData
{


    ArrayList list = new ArrayList();
    public static NonSerializableTestData createObj()
    {
        NonSerializableTestData obj = new NonSerializableTestData();
        obj.x = new Random().nextInt();

        for (int i=0;i<100;i++)
        {
            obj.list.add(NonSerializableTestData2.createObj());
        }
        return obj;
    }

    int x;

    private NonSerializableTestData()
    {
        System.out.println("Constructor was used");
    }

    public int hashCode() {
        return x;
    }

    public boolean equals(Object obj) {
        boolean equalsResult = (x==((NonSerializableTestData)obj).x);

        if (equalsResult)
        {
            equalsResult = list.equals(((NonSerializableTestData)obj).list);
        }

        return equalsResult;
    }

    public String toString()
    {
        return "NonSerializableTestData(x=" + x + ")";
    }
}
