/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/

package org.jboss.serial.nonserializable;

import java.util.Random;

/**
 * $Id: NonSerializableTestData2.java 252 2006-04-26 22:08:00Z csuconic $
 *
 * @author <a href="mailto:clebert.suconic@jboss.com">Clebert Suconic</a>
 */
public class NonSerializableTestData2 extends SuperClassTestData
{

    public static NonSerializableTestData2 createObj()
    {
        NonSerializableTestData2 x = new NonSerializableTestData2 ();
        x.x2 = new Random().nextInt();
        x.tst = new Random().nextInt();
        return x;
    }

    private NonSerializableTestData2 ()
    {
    }
    int x2;


    public int hashCode() {
        return x2;
    }

    public boolean equals(Object obj) {
        return x2==((NonSerializableTestData2)obj).x2 && tst == ((NonSerializableTestData2)obj).tst;
    }
}
