/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/

package org.jboss.serial.regression.jbser80;

import java.util.ArrayList;

import org.jboss.serial.benchmarks.SizeBenchmarkTestCase;
import org.jboss.serial.classmetamodel.ClassMetaData;
import org.jboss.serial.classmetamodel.ClassMetadataField;
import org.jboss.serial.classmetamodel.ClassMetamodelFactory;
import org.jboss.serial.data.TestPrivateExternalizable;
import org.jboss.serial.references.PersistentReference;

import junit.framework.TestCase;

public class RegressionTestCase extends TestCase
{

	public void testRegressionTest1() throws Exception
	{
		TestPrivateExternalizable test = TestPrivateExternalizable.createTestInstance();
		SizeBenchmarkTestCase bench = new SizeBenchmarkTestCase();
		bench.doTestJBossSerialization(test);
		
		// force reconstruction of SoftReferences
		
		ArrayList list = new ArrayList();
		int i=0;
		try
		{
			while (true)
			{
				list.add("Big String Big String Big String Big String Big String Big String Big String Big String Big String " + i);
				
			}
		}
		catch (Throwable e)
		{
		}
		list.clear();
		list = null;
		bench.doTestJBossSerialization(test);
		
	}
	
}
